diff --git lang/qt/src/Makefile.am lang/qt/src/Makefile.am
index 87e2ec2..71df154 100644
--- lang/qt/src/Makefile.am
+++ lang/qt/src/Makefile.am
@@ -17,7 +17,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 # 02111-1307, USA
-lib_LTLIBRARIES = libqgpgme.la
+lib_LTLIBRARIES = libq5gpgme.la
 EXTRA_DIST = QGpgmeConfig.cmake.in.in QGpgmeConfigVersion.cmake.in \
              gpgme_backend_debug.h qgpgme_version.h.in \
              QGpgmeConfig.cmake.in.in
@@ -209,15 +209,15 @@ camelcaseincludedir = $(includedir)/QGpgME
 camelcaseinclude_HEADERS = $(camelcase_headers)
 nodist_qgpgmeinclude_HEADERS = qgpgme_version.h
 
-libqgpgme_la_SOURCES = $(qgpgme_sources) $(qgpgme_headers) $(private_qgpgme_headers)
+libq5gpgme_la_SOURCES = $(qgpgme_sources) $(qgpgme_headers) $(private_qgpgme_headers)
 
 AM_CPPFLAGS = -I$(top_srcdir)/lang/cpp/src -I$(top_builddir)/src \
               @GPGME_QT_CFLAGS@ @GPG_ERROR_CFLAGS@ @LIBASSUAN_CFLAGS@ \
               -DBUILDING_QGPGME
 
-libqgpgme_la_LIBADD = ../../cpp/src/libgpgmepp.la ../../../src/libgpgme.la \
+libq5gpgme_la_LIBADD = ../../cpp/src/libgpgmepp.la ../../../src/libgpgme.la \
                        @LIBASSUAN_LIBS@ @GPGME_QT_LIBS@
-libqgpgme_la_LDFLAGS = -no-undefined -version-info \
+libq5gpgme_la_LDFLAGS = -no-undefined -version-info \
     @LIBQGPGME_LT_CURRENT@:@LIBQGPGME_LT_REVISION@:@LIBQGPGME_LT_AGE@
 
 if HAVE_W32_SYSTEM
@@ -258,7 +258,7 @@ CLEANFILES = $(qgpgme_moc_sources) $(camelcase_headers) QGpgmeConfig.cmake \
              qgpgme_version.h QGpgmeConfig.cmake.in \
              QGpgmeConfigVersion.cmake
 
-nodist_libqgpgme_la_SOURCES = $(qgpgme_moc_sources)
+nodist_libq5gpgme_la_SOURCES = $(qgpgme_moc_sources)
 
 .h.moc:
 	$(MOC) `test -f '$<' || echo '$(srcdir)/'`$< -o $@
diff --git lang/qt/src/Makefile.in lang/qt/src/Makefile.in
index 5b87f6e..14c4880 100644
--- lang/qt/src/Makefile.in
+++ lang/qt/src/Makefile.in
@@ -138,7 +138,7 @@ am__installdirs = "$(DESTDIR)$(libdir)" \
 	"$(DESTDIR)$(qgpgmeincludedir)" \
 	"$(DESTDIR)$(qgpgmeincludedir)"
 LTLIBRARIES = $(lib_LTLIBRARIES)
-libqgpgme_la_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
+libq5gpgme_la_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
 	../../../src/libgpgme.la
 am__objects_1 = dataprovider.lo job.lo multideletejob.lo \
 	qgpgmeadduseridjob.lo qgpgmebackend.lo \
@@ -156,18 +156,18 @@ am__objects_1 = dataprovider.lo job.lo multideletejob.lo \
 	gpgme_backend_debug.lo qgpgmetofupolicyjob.lo \
 	defaultkeygenerationjob.lo qgpgmewkspublishjob.lo dn.lo
 am__objects_2 =
-am_libqgpgme_la_OBJECTS = $(am__objects_1) $(am__objects_2) \
+am_libq5gpgme_la_OBJECTS = $(am__objects_1) $(am__objects_2) \
 	$(am__objects_2)
-nodist_libqgpgme_la_OBJECTS = $(am__objects_2)
-libqgpgme_la_OBJECTS = $(am_libqgpgme_la_OBJECTS) \
-	$(nodist_libqgpgme_la_OBJECTS)
+nodist_libq5gpgme_la_OBJECTS = $(am__objects_2)
+libq5gpgme_la_OBJECTS = $(am_libq5gpgme_la_OBJECTS) \
+	$(nodist_libq5gpgme_la_OBJECTS)
 AM_V_lt = $(am__v_lt_@AM_V@)
 am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
 am__v_lt_0 = --silent
 am__v_lt_1 = 
-libqgpgme_la_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CXX $(AM_LIBTOOLFLAGS) \
+libq5gpgme_la_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CXX $(AM_LIBTOOLFLAGS) \
 	$(LIBTOOLFLAGS) --mode=link $(CXXLD) $(AM_CXXFLAGS) \
-	$(CXXFLAGS) $(libqgpgme_la_LDFLAGS) $(LDFLAGS) -o $@
+	$(CXXFLAGS) $(libq5gpgme_la_LDFLAGS) $(LDFLAGS) -o $@
 AM_V_P = $(am__v_P_@AM_V@)
 am__v_P_ = $(am__v_P_@AM_DEFAULT_V@)
 am__v_P_0 = false
@@ -220,8 +220,8 @@ AM_V_CCLD = $(am__v_CCLD_@AM_V@)
 am__v_CCLD_ = $(am__v_CCLD_@AM_DEFAULT_V@)
 am__v_CCLD_0 = @echo "  CCLD    " $@;
 am__v_CCLD_1 = 
-SOURCES = $(libqgpgme_la_SOURCES) $(nodist_libqgpgme_la_SOURCES)
-DIST_SOURCES = $(libqgpgme_la_SOURCES)
+SOURCES = $(libq5gpgme_la_SOURCES) $(nodist_libq5gpgme_la_SOURCES)
+DIST_SOURCES = $(libq5gpgme_la_SOURCES)
 am__can_run_installinfo = \
   case $$AM_UPDATE_INFO_DIR in \
     n|no|NO) false;; \
@@ -464,7 +464,7 @@ top_srcdir = @top_srcdir@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 # 02111-1307, USA
-lib_LTLIBRARIES = libqgpgme.la
+lib_LTLIBRARIES = libq5gpgme.la
 EXTRA_DIST = QGpgmeConfig.cmake.in.in QGpgmeConfigVersion.cmake.in \
              gpgme_backend_debug.h qgpgme_version.h.in \
              QGpgmeConfig.cmake.in.in
@@ -656,15 +656,15 @@ qgpgmeinclude_HEADERS = $(qgpgme_headers)
 camelcaseincludedir = $(includedir)/QGpgME
 camelcaseinclude_HEADERS = $(camelcase_headers)
 nodist_qgpgmeinclude_HEADERS = qgpgme_version.h
-libqgpgme_la_SOURCES = $(qgpgme_sources) $(qgpgme_headers) $(private_qgpgme_headers)
+libq5gpgme_la_SOURCES = $(qgpgme_sources) $(qgpgme_headers) $(private_qgpgme_headers)
 AM_CPPFLAGS = -I$(top_srcdir)/lang/cpp/src -I$(top_builddir)/src \
               @GPGME_QT_CFLAGS@ @GPG_ERROR_CFLAGS@ @LIBASSUAN_CFLAGS@ \
               -DBUILDING_QGPGME
 
-libqgpgme_la_LIBADD = ../../cpp/src/libgpgmepp.la ../../../src/libgpgme.la \
+libq5gpgme_la_LIBADD = ../../cpp/src/libgpgmepp.la ../../../src/libgpgme.la \
                        @LIBASSUAN_LIBS@ @GPGME_QT_LIBS@
 
-libqgpgme_la_LDFLAGS = -no-undefined -version-info \
+libq5gpgme_la_LDFLAGS = -no-undefined -version-info \
     @LIBQGPGME_LT_CURRENT@:@LIBQGPGME_LT_REVISION@:@LIBQGPGME_LT_AGE@
 
 BUILT_SOURCES = $(qgpgme_moc_sources) $(camelcase_headers)
@@ -672,7 +672,7 @@ CLEANFILES = $(qgpgme_moc_sources) $(camelcase_headers) QGpgmeConfig.cmake \
              qgpgme_version.h QGpgmeConfig.cmake.in \
              QGpgmeConfigVersion.cmake
 
-nodist_libqgpgme_la_SOURCES = $(qgpgme_moc_sources)
+nodist_libq5gpgme_la_SOURCES = $(qgpgme_moc_sources)
 all: $(BUILT_SOURCES)
 	$(MAKE) $(AM_MAKEFLAGS) all-am
 
@@ -752,8 +752,8 @@ clean-libLTLIBRARIES:
 	  rm -f $${locs}; \
 	}
 
-libqgpgme.la: $(libqgpgme_la_OBJECTS) $(libqgpgme_la_DEPENDENCIES) $(EXTRA_libqgpgme_la_DEPENDENCIES) 
-	$(AM_V_CXXLD)$(libqgpgme_la_LINK) -rpath $(libdir) $(libqgpgme_la_OBJECTS) $(libqgpgme_la_LIBADD) $(LIBS)
+libq5gpgme.la: $(libq5gpgme_la_OBJECTS) $(libq5gpgme_la_DEPENDENCIES) $(EXTRA_libq5gpgme_la_DEPENDENCIES) 
+	$(AM_V_CXXLD)$(libq5gpgme_la_LINK) -rpath $(libdir) $(libq5gpgme_la_OBJECTS) $(libq5gpgme_la_LIBADD) $(LIBS)
 
 mostlyclean-compile:
 	-rm -f *.$(OBJEXT)
diff --git lang/qt/src/QGpgmeConfig-w32.cmake.in.in lang/qt/src/QGpgmeConfig-w32.cmake.in.in
index b897805..579b23e 100644
--- lang/qt/src/QGpgmeConfig-w32.cmake.in.in
+++ lang/qt/src/QGpgmeConfig-w32.cmake.in.in
@@ -62,14 +62,14 @@ unset(_expectedTargets)
 add_library(QGpgme SHARED IMPORTED)
 
 set_target_properties(QGpgme PROPERTIES
-  IMPORTED_IMPLIB_RELEASE "@resolved_libdir@/libqgpgme.dll.a"
+  IMPORTED_IMPLIB_RELEASE "@resolved_libdir@/libq5gpgme.dll.a"
   INTERFACE_INCLUDE_DIRECTORIES "@resolved_includedir@/qgpgme;@resolved_includedir@"
   INTERFACE_LINK_LIBRARIES "Gpgmepp;Qt5::Core"
-  IMPORTED_LOCATION "@resolved_libdir@/libqgpgme-7.dll"
+  IMPORTED_LOCATION "@resolved_libdir@/libq5gpgme-7.dll"
 )
 
 list(APPEND _IMPORT_CHECK_TARGETS QGgpme )
-list(APPEND _IMPORT_CHECK_FILES_FOR_Qgpgme "@resolved_libdir@/libqgpgme.dll.a" "@resolved_bindir@/libqgpgme-7.dll" )
+list(APPEND _IMPORT_CHECK_FILES_FOR_Qgpgme "@resolved_libdir@/libq5gpgme.dll.a" "@resolved_bindir@/libq5gpgme-7.dll" )
 
 if(CMAKE_VERSION VERSION_LESS 2.8.12)
   message(FATAL_ERROR "This file relies on consumers using CMake 2.8.12 or greater.")
diff --git lang/qt/src/QGpgmeConfig.cmake.in.in lang/qt/src/QGpgmeConfig.cmake.in.in
index 88ed242..e381ef4 100644
--- lang/qt/src/QGpgmeConfig.cmake.in.in
+++ lang/qt/src/QGpgmeConfig.cmake.in.in
@@ -64,7 +64,7 @@ add_library(QGpgme SHARED IMPORTED)
 set_target_properties(QGpgme PROPERTIES
   INTERFACE_INCLUDE_DIRECTORIES "@resolved_includedir@/qgpgme;@resolved_includedir@"
   INTERFACE_LINK_LIBRARIES "Gpgmepp;Qt5::Core"
-  IMPORTED_LOCATION "@resolved_libdir@/libqgpgme.so"
+  IMPORTED_LOCATION "@resolved_libdir@/libq5gpgme.so"
 )
 
 if(CMAKE_VERSION VERSION_LESS 2.8.12)
diff --git lang/qt/tests/Makefile.am lang/qt/tests/Makefile.am
index ad08ad4..b3f574a 100644
--- lang/qt/tests/Makefile.am
+++ lang/qt/tests/Makefile.am
@@ -32,7 +32,7 @@ moc_files = t-keylist.moc t-keylocate.moc t-ownertrust.moc t-tofuinfo.moc \
 
 AM_LDFLAGS = -no-install
 
-LDADD = ../../cpp/src/libgpgmepp.la ../src/libqgpgme.la \
+LDADD = ../../cpp/src/libgpgmepp.la ../src/libq5gpgme.la \
         ../../../src/libgpgme.la @GPGME_QT_LIBS@ @GPG_ERROR_LIBS@ \
         @GPGME_QTTEST_LIBS@ -lstdc++
 
diff --git lang/qt/tests/Makefile.in lang/qt/tests/Makefile.in
index e0ac22e..788ed6d 100644
--- lang/qt/tests/Makefile.in
+++ lang/qt/tests/Makefile.in
@@ -130,7 +130,7 @@ am_run_keyformailboxjob_OBJECTS = run-keyformailboxjob.$(OBJEXT)
 run_keyformailboxjob_OBJECTS = $(am_run_keyformailboxjob_OBJECTS)
 run_keyformailboxjob_LDADD = $(LDADD)
 run_keyformailboxjob_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 AM_V_lt = $(am__v_lt_@AM_V@)
 am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
 am__v_lt_0 = --silent
@@ -140,7 +140,7 @@ am_t_encrypt_OBJECTS = t-encrypt.$(OBJEXT) $(am__objects_1)
 t_encrypt_OBJECTS = $(am_t_encrypt_OBJECTS)
 t_encrypt_LDADD = $(LDADD)
 t_encrypt_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 am_t_keylist_OBJECTS = t-keylist.$(OBJEXT) $(am__objects_1)
 am__objects_2 =
 nodist_t_keylist_OBJECTS = $(am__objects_2)
@@ -148,32 +148,32 @@ t_keylist_OBJECTS = $(am_t_keylist_OBJECTS) \
 	$(nodist_t_keylist_OBJECTS)
 t_keylist_LDADD = $(LDADD)
 t_keylist_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 am_t_keylocate_OBJECTS = t-keylocate.$(OBJEXT) $(am__objects_1)
 t_keylocate_OBJECTS = $(am_t_keylocate_OBJECTS)
 t_keylocate_LDADD = $(LDADD)
 t_keylocate_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 am_t_ownertrust_OBJECTS = t-ownertrust.$(OBJEXT) $(am__objects_1)
 t_ownertrust_OBJECTS = $(am_t_ownertrust_OBJECTS)
 t_ownertrust_LDADD = $(LDADD)
 t_ownertrust_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 am_t_tofuinfo_OBJECTS = t-tofuinfo.$(OBJEXT) $(am__objects_1)
 t_tofuinfo_OBJECTS = $(am_t_tofuinfo_OBJECTS)
 t_tofuinfo_LDADD = $(LDADD)
 t_tofuinfo_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 am_t_verify_OBJECTS = t-verify.$(OBJEXT) $(am__objects_1)
 t_verify_OBJECTS = $(am_t_verify_OBJECTS)
 t_verify_LDADD = $(LDADD)
 t_verify_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 am_t_wkspublish_OBJECTS = t-wkspublish.$(OBJEXT) $(am__objects_1)
 t_wkspublish_OBJECTS = $(am_t_wkspublish_OBJECTS)
 t_wkspublish_LDADD = $(LDADD)
 t_wkspublish_DEPENDENCIES = ../../cpp/src/libgpgmepp.la \
-	../src/libqgpgme.la ../../../src/libgpgme.la
+	../src/libq5gpgme.la ../../../src/libgpgme.la
 AM_V_P = $(am__v_P_@AM_V@)
 am__v_P_ = $(am__v_P_@AM_DEFAULT_V@)
 am__v_P_0 = false
@@ -484,7 +484,7 @@ moc_files = t-keylist.moc t-keylocate.moc t-ownertrust.moc t-tofuinfo.moc \
             t-encrypt.moc t-support.hmoc t-wkspublish.moc t-verify.moc
 
 AM_LDFLAGS = -no-install
-LDADD = ../../cpp/src/libgpgmepp.la ../src/libqgpgme.la \
+LDADD = ../../cpp/src/libgpgmepp.la ../src/libq5gpgme.la \
         ../../../src/libgpgme.la @GPGME_QT_LIBS@ @GPG_ERROR_LIBS@ \
         @GPGME_QTTEST_LIBS@ -lstdc++
 