diff --git a/x11/wine-crossover/Portfile b/x11/wine-crossover/Portfile
index 4237932b3b..4a66399543 100644
--- a/x11/wine-crossover/Portfile
+++ b/x11/wine-crossover/Portfile
@@ -1,5 +1,4 @@
 # -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4
-# $Id$
 
 PortSystem                  1.0
 PortGroup                   compiler_blacklist_versions 1.0
@@ -15,7 +14,7 @@ PortGroup                   compiler_blacklist_versions 1.0
 name                        wine-crossover
 conflicts                   wine wine-devel
 set my_name                 wine
-version                     15.3.1
+version                     16.0.0
 license                     LGPL-2.1+
 categories                  x11
 maintainers                 jeremyhu openmaintainer
@@ -24,15 +23,15 @@ platforms                   darwin
 distname                    crossover-sources-${version}
 dist_subdir                 ${my_name}
 set wine_distfile           ${distname}${extract.suffix}
-set wine_gecko_version      2.40
+set wine_gecko_version      2.47
 set wine_gecko_distfile     wine_gecko-${wine_gecko_version}-x86.msi
-set wine_mono_version       4.5.6
+set wine_mono_version       4.6.3
 set wine_mono_distfile      wine-mono-${wine_mono_version}.msi
 worksrcdir                  sources/wine
 build.target                depend all
 use_parallel_build          yes
 
-description                 Wine Is Not an Emulator (1.8.4 with CodeWeavers modifications for CrossOver)
+description                 Wine Is Not an Emulator (1.9.21 with CodeWeavers modifications for CrossOver)
 
 long_description            Wine is an implementation of the Windows APIs on top of X11. \
                             This version contains the Codeweavers patches for CrossOver
@@ -51,24 +50,25 @@ distfiles                   ${wine_distfile}:winesource \
                             ${wine_mono_distfile}:winemono
 
 checksums                   ${wine_distfile} \
-                            rmd160  234b700626c8775eb07a3673330dbd4f87e63fb9 \
-                            sha256  aeda0ecc357c879e209c50e339050da86121b684c7acd1bfbea3202938d89336 \
+                            rmd160  86d50830f012075ff5c993cb0980abdad1ff4f48 \
+                            sha256  b0cd0f90b09a8a02f805cccfeed4487fed02456b601ec19a5871dc8fe1d9227d \
                             ${wine_gecko_distfile} \
-                            rmd160  2b0e0b6c5cd7579579a27bf179f98b7a76f4f43c \
-                            sha256  1a29d17435a52b7663cea6f30a0771f74097962b07031947719bb7b46057d302 \
+                            rmd160  abf7cc78b49dd0623bc8fe87ae0e32bb8694e13d \
+                            sha256  3b8a361f5d63952d21caafd74e849a774994822fb96c5922b01d554f1677643a \
                             ${wine_mono_distfile} \
-                            rmd160  440a0839e6067eb02b778cbb461606a7d498897b \
-                            sha256  ac681f737f83742d786706529eb85f4bc8d6bdddd8dcdfa9e2e336b71973bc25
+                            rmd160  2dff4296d74c29838219dcd50aaf928f1eb8c8ab \
+                            sha256  f883e88ae78c7ea3d887c24023aa1ed03bb71a83f717c6595abf18b31fef28b9
 
 # Note: Most of the X11 libs are dlopen()'d
 depends_lib                 port:expat \
                             port:fontconfig \
                             port:freetype \
-                            port:gstreamer010 \
-                            port:gstreamer010-gst-plugins-base \
+                            port:gstreamer1 \
+                            port:gstreamer1-gst-plugins-base \
                             port:jpeg \
                             port:lcms2 \
                             port:libiconv \
+                            port:libpcap \
                             port:libpng \
                             port:libxml2 \
                             port:libxslt \
@@ -92,6 +92,7 @@ depends_build               port:bison \
                             port:pkgconfig
 
 patchfiles                  BOOL.patch \
+                            cups_headers.patch \
                             mach_machine.patch \
                             patch-include-distversion.h.diff \
                             tiger-shell.patch